
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATtiny2313
;Program type             : Application
;Clock frequency          : 16.000000 MHz
;Memory model             : Tiny
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 32 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _msec=R3
	.DEF _sec=R2
	.DEF _min=R5
	.DEF _hour=R4
	.DEF _i=R7

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _pin_change_isr0
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x76:
	.DB  0x1,0x1,0x1,0x1,0x0,0xA

__GLOBAL_INI_TBL:
	.DW  0x06
	.DW  0x02
	.DW  _0x76*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,0x00
	OUT  GPIOR0,R30
	OUT  GPIOR1,R30
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.4a Advanced
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 07.09.2011
;Author  : NeVaDa
;Company : CDRR
;Comments:
;
;
;Chip type               : ATtiny2313
;AVR Core Clock frequency: 8.000000 MHz
;Memory model            : Tiny
;External RAM size       : 0
;Data Stack size         : 32
;*****************************************************/
;
;#include <tiny2313.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;unsigned char msec=1;
;unsigned char sec=1;
;unsigned char min=1;
;unsigned char hour=1;
;char i=10;
;eeprom char mode=0; // . 1 , 2 ,   1 , 3    , 4 -  ..    
;eeprom char DelayTime=10;
;
;// Timer1 output compare A interrupt service routine
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)
; 0000 0024 {

	.CSEG
_timer1_compa_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0025 // Place your code here
; 0000 0026 msec++;
	INC  R3
; 0000 0027 if (msec>99)
	LDI  R30,LOW(99)
	CP   R30,R3
	BRSH _0x3
; 0000 0028     {
; 0000 0029         msec=0;
	CLR  R3
; 0000 002A         sec++;
	INC  R2
; 0000 002B         if (sec>59)
	LDI  R30,LOW(59)
	CP   R30,R2
	BRSH _0x4
; 0000 002C             {
; 0000 002D                 sec=0;
	CLR  R2
; 0000 002E                 min++;
	INC  R5
; 0000 002F                 if (min>59)
	CP   R30,R5
	BRSH _0x5
; 0000 0030                     {
; 0000 0031                         min=0;
	CLR  R5
; 0000 0032                         hour++;
	INC  R4
; 0000 0033                         if (hour>11)
	LDI  R30,LOW(11)
	CP   R30,R4
	BRSH _0x6
; 0000 0034                             {
; 0000 0035                                 hour=0;
	CLR  R4
; 0000 0036                             }
; 0000 0037                     }
_0x6:
; 0000 0038             }
_0x5:
; 0000 0039     }
_0x4:
; 0000 003A 
; 0000 003B TCNT1H=0x00;
_0x3:
	RCALL SUBOPT_0x0
; 0000 003C TCNT1L=0x00;
; 0000 003D }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;// Declare your global variables here
;void SetLed(char LedN, char ColorLed, char b)
; 0000 0041 {
_SetLed:
; 0000 0042     PORTD.0=ColorLed;
;	LedN -> Y+2
;	ColorLed -> Y+1
;	b -> Y+0
	LDD  R30,Y+1
	CPI  R30,0
	BRNE _0x7
	CBI  0x12,0
	RJMP _0x8
_0x7:
	SBI  0x12,0
_0x8:
; 0000 0043     switch(LedN)
	LDD  R30,Y+2
	RCALL SUBOPT_0x1
; 0000 0044     {
; 0000 0045     case 0:  PORTB.3=b; break;
	SBIW R30,0
	BRNE _0xC
	RCALL SUBOPT_0x2
	BRNE _0xD
	CBI  0x18,3
	RJMP _0xE
_0xD:
	SBI  0x18,3
_0xE:
	RJMP _0xB
; 0000 0046     case 1:  PORTB.2=b; break;
_0xC:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xF
	RCALL SUBOPT_0x2
	BRNE _0x10
	CBI  0x18,2
	RJMP _0x11
_0x10:
	SBI  0x18,2
_0x11:
	RJMP _0xB
; 0000 0047     case 2:  PORTB.1=b; break;
_0xF:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x12
	RCALL SUBOPT_0x2
	BRNE _0x13
	CBI  0x18,1
	RJMP _0x14
_0x13:
	SBI  0x18,1
_0x14:
	RJMP _0xB
; 0000 0048     case 3:  PORTB.0=b; break;
_0x12:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x15
	RCALL SUBOPT_0x2
	BRNE _0x16
	CBI  0x18,0
	RJMP _0x17
_0x16:
	SBI  0x18,0
_0x17:
	RJMP _0xB
; 0000 0049     case 4:  PORTD.6=b; break;
_0x15:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x18
	RCALL SUBOPT_0x2
	BRNE _0x19
	CBI  0x12,6
	RJMP _0x1A
_0x19:
	SBI  0x12,6
_0x1A:
	RJMP _0xB
; 0000 004A     case 5:  PORTD.5=b; break;
_0x18:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x1B
	RCALL SUBOPT_0x2
	BRNE _0x1C
	CBI  0x12,5
	RJMP _0x1D
_0x1C:
	SBI  0x12,5
_0x1D:
	RJMP _0xB
; 0000 004B     case 6:  PORTD.4=b; break;
_0x1B:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x1E
	RCALL SUBOPT_0x2
	BRNE _0x1F
	CBI  0x12,4
	RJMP _0x20
_0x1F:
	SBI  0x12,4
_0x20:
	RJMP _0xB
; 0000 004C     case 7:  PORTD.3=b; break;
_0x1E:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x21
	RCALL SUBOPT_0x2
	BRNE _0x22
	CBI  0x12,3
	RJMP _0x23
_0x22:
	SBI  0x12,3
_0x23:
	RJMP _0xB
; 0000 004D     case 8:  PORTD.2=b; break;
_0x21:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x24
	RCALL SUBOPT_0x2
	BRNE _0x25
	CBI  0x12,2
	RJMP _0x26
_0x25:
	SBI  0x12,2
_0x26:
	RJMP _0xB
; 0000 004E     case 9:  PORTD.1=b; break;
_0x24:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x27
	RCALL SUBOPT_0x2
	BRNE _0x28
	CBI  0x12,1
	RJMP _0x29
_0x28:
	SBI  0x12,1
_0x29:
	RJMP _0xB
; 0000 004F     case 10: PORTB.5=b; break;
_0x27:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x2A
	RCALL SUBOPT_0x2
	BRNE _0x2B
	CBI  0x18,5
	RJMP _0x2C
_0x2B:
	SBI  0x18,5
_0x2C:
	RJMP _0xB
; 0000 0050     case 11: PORTB.4=b; break;
_0x2A:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BRNE _0x2D
	RCALL SUBOPT_0x2
	BRNE _0x2E
	CBI  0x18,4
	RJMP _0x2F
_0x2E:
	SBI  0x18,4
_0x2F:
	RJMP _0xB
; 0000 0051     case 12: PORTB.3=b; break;
_0x2D:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BRNE _0x30
	RCALL SUBOPT_0x2
	BRNE _0x31
	CBI  0x18,3
	RJMP _0x32
_0x31:
	SBI  0x18,3
_0x32:
	RJMP _0xB
; 0000 0052     case 99: {PORTB=0b11111111; PORTD=0b01111110; break;}
_0x30:
	CPI  R30,LOW(0x63)
	LDI  R26,HIGH(0x63)
	CPC  R31,R26
	BRNE _0x33
	LDI  R30,LOW(255)
	OUT  0x18,R30
	LDI  R30,LOW(126)
	OUT  0x12,R30
	RJMP _0xB
; 0000 0053     case 50: {PORTB=0b11000000; PORTD=0b00000000; break;}
_0x33:
	CPI  R30,LOW(0x32)
	LDI  R26,HIGH(0x32)
	CPC  R31,R26
	BRNE _0xB
	LDI  R30,LOW(192)
	OUT  0x18,R30
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 0054     break;
; 0000 0055     }
_0xB:
; 0000 0056 }
	ADIW R28,3
	RET
;
;// Pin change 0-7 interrupt service routine
;interrupt [PC_INT] void pin_change_isr0(void)
; 0000 005A {
_pin_change_isr0:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 005B // Place your code here
; 0000 005C       if (!PINB.6)
	SBIC 0x16,6
	RJMP _0x35
; 0000 005D         {
; 0000 005E             if (mode==1) { min+=5; if (min>59) min=0;}
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x1)
	BRNE _0x36
	RCALL SUBOPT_0x4
	BRSH _0x37
	CLR  R5
_0x37:
; 0000 005F             if (mode==0) { hour+=1; if (hour>11) hour=0;}
_0x36:
	RCALL SUBOPT_0x3
	CPI  R30,0
	BRNE _0x38
	INC  R4
	LDI  R30,LOW(11)
	CP   R30,R4
	BRSH _0x39
	CLR  R4
_0x39:
; 0000 0060             if (mode>1) {DelayTime-=1; if (DelayTime<1) DelayTime=1;}
_0x38:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x2)
	BRLO _0x3A
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
	SBIW R30,1
	RCALL SUBOPT_0x7
	CPI  R30,LOW(0x1)
	BRSH _0x3B
	RCALL SUBOPT_0x5
	LDI  R30,LOW(1)
	RCALL __EEPROMWRB
_0x3B:
; 0000 0061             delay_ms(300);
_0x3A:
	RCALL SUBOPT_0x8
; 0000 0062         }
; 0000 0063       if (!PINB.7)
_0x35:
	SBIC 0x16,7
	RJMP _0x3C
; 0000 0064         {
; 0000 0065             if (mode==1) { sec+=5; if (sec>59) sec=0;}
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x1)
	BRNE _0x3D
	LDI  R30,LOW(5)
	ADD  R2,R30
	LDI  R30,LOW(59)
	CP   R30,R2
	BRSH _0x3E
	CLR  R2
_0x3E:
; 0000 0066             if (mode==0) { min+=5; if (min>59) min=0;}
_0x3D:
	RCALL SUBOPT_0x3
	CPI  R30,0
	BRNE _0x3F
	RCALL SUBOPT_0x4
	BRSH _0x40
	CLR  R5
_0x40:
; 0000 0067             if (mode>1) {DelayTime+=1; if (DelayTime>100) DelayTime=100;}
_0x3F:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x2)
	BRLO _0x41
	RCALL SUBOPT_0x5
	RCALL __EEPROMRDB
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x7
	CPI  R30,LOW(0x65)
	BRLO _0x42
	RCALL SUBOPT_0x5
	LDI  R30,LOW(100)
	RCALL __EEPROMWRB
_0x42:
; 0000 0068             delay_ms(300);
_0x41:
	RCALL SUBOPT_0x8
; 0000 0069 
; 0000 006A 
; 0000 006B           if (!PINB.6)
	SBIC 0x16,6
	RJMP _0x43
; 0000 006C             {
; 0000 006D                 mode++;
	RCALL SUBOPT_0x3
	SUBI R30,-LOW(1)
	RCALL __EEPROMWRB
	SUBI R30,LOW(1)
; 0000 006E                 if (mode>13) mode=0;
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0xE)
	BRLO _0x44
	LDI  R26,LOW(_mode)
	LDI  R27,HIGH(_mode)
	LDI  R30,LOW(0)
	RCALL __EEPROMWRB
; 0000 006F                 delay_ms(100);
_0x44:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x9
; 0000 0070             }
; 0000 0071         }
_0x43:
; 0000 0072 
; 0000 0073 }
_0x3C:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;void animate1(void )
; 0000 0076 {
_animate1:
; 0000 0077         i=1;
	RCALL SUBOPT_0xA
; 0000 0078         SetLed(50,1,0);
	RCALL SUBOPT_0xB
; 0000 0079         delay_ms(DelayTime*7);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
; 0000 007A //        PORTD.0=0;
; 0000 007B          for (i=1;i<13;i++)
	RCALL SUBOPT_0xA
_0x46:
	RCALL SUBOPT_0xE
	BRSH _0x47
; 0000 007C          {
; 0000 007D             SetLed(i,1,1);
	RCALL SUBOPT_0xF
; 0000 007E             delay_ms(DelayTime*4);
	RCALL SUBOPT_0x10
; 0000 007F          };
	INC  R7
	RJMP _0x46
_0x47:
; 0000 0080          for (i=1;i<13;i++)
	RCALL SUBOPT_0xA
_0x49:
	RCALL SUBOPT_0xE
	BRSH _0x4A
; 0000 0081          {
; 0000 0082             SetLed(13-i,1,0);
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
; 0000 0083             delay_ms(DelayTime*4);
	RCALL SUBOPT_0x10
; 0000 0084          };
	INC  R7
	RJMP _0x49
_0x4A:
; 0000 0085         SetLed(99,0,0);
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
; 0000 0086         delay_ms(DelayTime*7);
	RCALL SUBOPT_0xD
; 0000 0087 //        PORTD.0=1;
; 0000 0088          for (i=1;i<13;i++)
	RCALL SUBOPT_0xA
_0x4C:
	RCALL SUBOPT_0xE
	BRSH _0x4D
; 0000 0089          {
; 0000 008A             SetLed(i,0,0);
	ST   -Y,R7
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
; 0000 008B             delay_ms(DelayTime*4);
	RCALL SUBOPT_0x10
; 0000 008C          };
	INC  R7
	RJMP _0x4C
_0x4D:
; 0000 008D          for (i=1;i<13;i++)
	RCALL SUBOPT_0xA
_0x4F:
	RCALL SUBOPT_0xE
	BRSH _0x50
; 0000 008E          {
; 0000 008F             SetLed(13-i,0,1);
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x14
; 0000 0090             delay_ms(DelayTime*4);
	RCALL SUBOPT_0x10
; 0000 0091          };
	INC  R7
	RJMP _0x4F
_0x50:
; 0000 0092 
; 0000 0093 }
	RET
;
;void animate2(void )
; 0000 0096 {
_animate2:
; 0000 0097 i=1;
	RCALL SUBOPT_0xA
; 0000 0098 for (i=1;i<13;i++)
	RCALL SUBOPT_0xA
_0x52:
	RCALL SUBOPT_0xE
	BRSH _0x53
; 0000 0099     {
; 0000 009A         SetLed(99,0,0);
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x13
	RCALL _SetLed
; 0000 009B         SetLed(i,0,0);
	ST   -Y,R7
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
; 0000 009C         delay_ms(DelayTime*10);
	RCALL SUBOPT_0x16
; 0000 009D     }
	INC  R7
	RJMP _0x52
_0x53:
; 0000 009E }
	RET
;
;void animate3(void )
; 0000 00A1 {
_animate3:
; 0000 00A2 i=1;
	RCALL SUBOPT_0xA
; 0000 00A3 for (i=1;i<13;i++)
	RCALL SUBOPT_0xA
_0x55:
	RCALL SUBOPT_0xE
	BRSH _0x56
; 0000 00A4     {
; 0000 00A5         SetLed(50,1,0);
	RCALL SUBOPT_0xB
; 0000 00A6         SetLed(i,1,1);
	RCALL SUBOPT_0xF
; 0000 00A7         delay_ms(DelayTime*10);
	RCALL SUBOPT_0x16
; 0000 00A8     }
	INC  R7
	RJMP _0x55
_0x56:
; 0000 00A9 }
	RET
;
;void animate4(void )   //  360
; 0000 00AC {
_animate4:
; 0000 00AD i=10;
	LDI  R30,LOW(10)
	MOV  R7,R30
; 0000 00AE for (i=10;i<130;i++)
	MOV  R7,R30
_0x58:
	LDI  R30,LOW(130)
	CP   R7,R30
	BRSH _0x59
; 0000 00AF     {
; 0000 00B0         SetLed(50,1,0);
	RCALL SUBOPT_0xB
; 0000 00B1         SetLed(i/10,1,1);
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x14
; 0000 00B2         delay_ms(DelayTime);
	RCALL SUBOPT_0x9
; 0000 00B3 
; 0000 00B4         SetLed(99,0,0);
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x18
; 0000 00B5         SetLed(i/10,0,0);
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
; 0000 00B6         delay_ms(DelayTime);
	RCALL SUBOPT_0x9
; 0000 00B7     }
	INC  R7
	RJMP _0x58
_0x59:
; 0000 00B8 }
	RET
;void animate6(void )    //  120 
; 0000 00BA {
_animate6:
; 0000 00BB i=11;
	RCALL SUBOPT_0x19
; 0000 00BC for (i=11;i<129;i++)
	RCALL SUBOPT_0x19
_0x5B:
	LDI  R30,LOW(129)
	CP   R7,R30
	BRSH _0x5C
; 0000 00BD     {
; 0000 00BE         SetLed(50,1,0);
	RCALL SUBOPT_0xB
; 0000 00BF         SetLed(i/10,1,1);
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x1A
; 0000 00C0         SetLed((i/10+3)%12+1,1,1);
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x1A
; 0000 00C1         SetLed((i/10+7)%12+1,1,1);
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x14
; 0000 00C2         delay_ms(DelayTime);
	RCALL SUBOPT_0x9
; 0000 00C3 
; 0000 00C4         SetLed(99,0,0);
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x18
; 0000 00C5         SetLed(i/10,0,0);
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x1A
; 0000 00C6         SetLed((i/10+3)%12+1,0,0);
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x1A
; 0000 00C7         SetLed((i/10+7)%12+1,0,0);
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
; 0000 00C8         delay_ms(DelayTime);
	RCALL SUBOPT_0x9
; 0000 00C9     }
	INC  R7
	RJMP _0x5B
_0x5C:
; 0000 00CA }
	RET
;void animate7(void ) //  90 
; 0000 00CC {
_animate7:
; 0000 00CD i=11;
	RCALL SUBOPT_0x19
; 0000 00CE for (i=11;i<129;i++)
	RCALL SUBOPT_0x19
_0x5E:
	LDI  R30,LOW(129)
	CP   R7,R30
	BRSH _0x5F
; 0000 00CF     {
; 0000 00D0         SetLed(50,1,0);
	RCALL SUBOPT_0xB
; 0000 00D1         SetLed(i/10,1,1);
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x1A
; 0000 00D2         SetLed((i/10+2)%12+1,1,1);
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x1A
; 0000 00D3         SetLed((i/10+5)%12+1,1,1);
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x1A
; 0000 00D4         SetLed((i/10+8)%12+1,1,1);
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x14
; 0000 00D5         delay_ms(DelayTime);
	RCALL SUBOPT_0x9
; 0000 00D6 
; 0000 00D7         SetLed(99,0,0);
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x18
; 0000 00D8         SetLed(i/10,0,0);
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x1A
; 0000 00D9         SetLed((i/10+2)%12+1,0,0);
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x1A
; 0000 00DA         SetLed((i/10+5)%12+1,0,0);
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x1A
; 0000 00DB         SetLed((i/10+8)%12+1,0,0);
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
; 0000 00DC         delay_ms(DelayTime);
	RCALL SUBOPT_0x9
; 0000 00DD     }
	INC  R7
	RJMP _0x5E
_0x5F:
; 0000 00DE }
	RET
;void animate5(void )   //  180
; 0000 00E0 {
_animate5:
; 0000 00E1 i=11;
	RCALL SUBOPT_0x19
; 0000 00E2 for (i=11;i<129;i++)
	RCALL SUBOPT_0x19
_0x61:
	LDI  R30,LOW(129)
	CP   R7,R30
	BRSH _0x62
; 0000 00E3     {
; 0000 00E4         SetLed(50,1,0);
	RCALL SUBOPT_0xB
; 0000 00E5         SetLed(i/10,1,1);
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x1A
; 0000 00E6         SetLed((i/10+5)%12+1,1,1);
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x14
; 0000 00E7         delay_ms(DelayTime);
	RCALL SUBOPT_0x9
; 0000 00E8 
; 0000 00E9         SetLed(99,0,0);
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x18
; 0000 00EA         SetLed(i/10,0,0);
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x1A
; 0000 00EB         SetLed((i/10+5)%12+1,0,0);
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
; 0000 00EC         delay_ms(DelayTime);
	RCALL SUBOPT_0x9
; 0000 00ED     }
	INC  R7
	RJMP _0x61
_0x62:
; 0000 00EE }
	RET
;
;void animate9(void )
; 0000 00F1 {
_animate9:
; 0000 00F2 SetLed(50,0,0);
	LDI  R30,LOW(50)
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x21
; 0000 00F3 delay_ms(5);
; 0000 00F4 SetLed(99,1,1);
	LDI  R30,LOW(99)
	ST   -Y,R30
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL _SetLed
; 0000 00F5 PORTD.0=1;
	SBI  0x12,0
; 0000 00F6 delay_ms(5);
	RJMP _0x2000003
; 0000 00F7 }
;
;
;void secundomer(void )
; 0000 00FB {
_secundomer:
; 0000 00FC         SetLed(50,1,0);
	RCALL SUBOPT_0xB
; 0000 00FD         SetLed(msec/8,1,1);
	RCALL SUBOPT_0x22
	ST   -Y,R30
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x21
; 0000 00FE         delay_ms(5);
; 0000 00FF 
; 0000 0100         SetLed(99,0,0);
	RJMP _0x2000002
; 0000 0101         SetLed(sec/5,0,0);
; 0000 0102         delay_ms(5);
; 0000 0103 }
;
;clock()
; 0000 0106 {
_clock:
; 0000 0107 
; 0000 0108         SetLed(50,1,0);
	RCALL SUBOPT_0xB
; 0000 0109         SetLed(hour,1,1);
	ST   -Y,R4
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x21
; 0000 010A         delay_ms(5);
; 0000 010B 
; 0000 010C         SetLed(50,1,0);
	RCALL SUBOPT_0xB
; 0000 010D         SetLed(0,1,1);
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x23
; 0000 010E         delay_us(300);
; 0000 010F 
; 0000 0110         SetLed(99,0,0);
	RCALL SUBOPT_0x13
	RCALL _SetLed
; 0000 0111         SetLed(msec/8,0,0);
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x23
; 0000 0112         delay_us(300);
; 0000 0113 
; 0000 0114         SetLed(99,0,0);
	RCALL SUBOPT_0x13
	RCALL _SetLed
; 0000 0115         SetLed(min/5,0,0);
	MOV  R26,R5
	RJMP _0x2000001
; 0000 0116         delay_ms(5);
; 0000 0117 }
;clock1()
; 0000 0119 {
_clock1:
; 0000 011A         SetLed(50,1,0);
	RCALL SUBOPT_0xB
; 0000 011B         SetLed(min/5,1,1);
	MOV  R26,R5
	LDI  R27,0
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL __DIVW21
	ST   -Y,R30
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x21
; 0000 011C         delay_ms(5);
; 0000 011D 
; 0000 011E         SetLed(99,0,0);
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x13
	RCALL _SetLed
; 0000 011F         SetLed(msec/8,0,0);
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x13
	RCALL _SetLed
; 0000 0120         delay_us(300);
	__DELAY_USW 1200
; 0000 0121 
; 0000 0122         SetLed(99,0,0);
_0x2000002:
	LDI  R30,LOW(99)
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x13
	RCALL _SetLed
; 0000 0123         SetLed(sec/5,0,0);
	MOV  R26,R2
_0x2000001:
	LDI  R27,0
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL __DIVW21
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x13
	RCALL _SetLed
; 0000 0124         delay_ms(5);
_0x2000003:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0x9
; 0000 0125 }
	RET
;
;
;void main(void)
; 0000 0129 {
_main:
; 0000 012A 
; 0000 012B PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 012C DDRA=0x00;
	OUT  0x1A,R30
; 0000 012D PORTB=0b11000000;
	LDI  R30,LOW(192)
	OUT  0x18,R30
; 0000 012E  DDRB=0b00111111;
	LDI  R30,LOW(63)
	OUT  0x17,R30
; 0000 012F PORTD=0b00111111;
	OUT  0x12,R30
; 0000 0130 DDRD=0x7F;
	LDI  R30,LOW(127)
	OUT  0x11,R30
; 0000 0131 
; 0000 0132 TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 0133 TCCR1B=0x04;
	LDI  R30,LOW(4)
	OUT  0x2E,R30
; 0000 0134 TCNT1H=0x00;
	RCALL SUBOPT_0x0
; 0000 0135 TCNT1L=0x00;
; 0000 0136 ICR1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x25,R30
; 0000 0137 ICR1L=0x00;
	OUT  0x24,R30
; 0000 0138 OCR1AH=0x02;
	LDI  R30,LOW(2)
	OUT  0x2B,R30
; 0000 0139 OCR1AL=0x71;
	LDI  R30,LOW(113)
	OUT  0x2A,R30
; 0000 013A OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
; 0000 013B OCR1BL=0x00;
	OUT  0x28,R30
; 0000 013C 
; 0000 013D GIMSK=0x20;
	LDI  R30,LOW(32)
	OUT  0x3B,R30
; 0000 013E MCUCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x35,R30
; 0000 013F PCMSK=0xC0;
	LDI  R30,LOW(192)
	OUT  0x20,R30
; 0000 0140 EIFR=0x20;
	LDI  R30,LOW(32)
	OUT  0x3A,R30
; 0000 0141 
; 0000 0142 TIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x39,R30
; 0000 0143 
; 0000 0144 #asm("sei")
	sei
; 0000 0145 
; 0000 0146 while (1)
_0x65:
; 0000 0147       {
; 0000 0148       // Place your code here
; 0000 0149       if (mode==0) clock();
	RCALL SUBOPT_0x3
	CPI  R30,0
	BRNE _0x68
	RCALL _clock
; 0000 014A       if (mode==1) clock1();
_0x68:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x1)
	BRNE _0x69
	RCALL _clock1
; 0000 014B       if (mode==2) secundomer();
_0x69:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x2)
	BRNE _0x6A
	RCALL _secundomer
; 0000 014C       if (mode==3) animate9();
_0x6A:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x3)
	BRNE _0x6B
	RCALL _animate9
; 0000 014D       if (mode==4) animate2();
_0x6B:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x4)
	BRNE _0x6C
	RCALL _animate2
; 0000 014E       if (mode==5) animate3();
_0x6C:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x5)
	BRNE _0x6D
	RCALL _animate3
; 0000 014F       if (mode==6) animate4();
_0x6D:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x6)
	BRNE _0x6E
	RCALL _animate4
; 0000 0150       if (mode==7) animate5();
_0x6E:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x7)
	BRNE _0x6F
	RCALL _animate5
; 0000 0151       if (mode==8) animate6();
_0x6F:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x8)
	BRNE _0x70
	RCALL _animate6
; 0000 0152       if (mode==9) animate7();
_0x70:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x9)
	BRNE _0x71
	RCALL _animate7
; 0000 0153       if (mode==10) animate1();
_0x71:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0xA)
	BRNE _0x72
	RCALL _animate1
; 0000 0154       if (mode==11) {animate2();animate3();}
_0x72:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0xB)
	BRNE _0x73
	RCALL _animate2
	RCALL _animate3
; 0000 0155       if (mode==12)
_0x73:
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0xC)
	BRNE _0x74
; 0000 0156         {
; 0000 0157            animate2();
	RCALL _animate2
; 0000 0158            animate2();
	RCALL _animate2
; 0000 0159            animate3();
	RCALL _animate3
; 0000 015A            animate3();
	RCALL _animate3
; 0000 015B            animate4();
	RCALL _animate4
; 0000 015C            animate4();
	RCALL _animate4
; 0000 015D            animate5();
	RCALL _animate5
; 0000 015E            animate5();
	RCALL _animate5
; 0000 015F            animate6();
	RCALL _animate6
; 0000 0160            animate6();
	RCALL _animate6
; 0000 0161            animate7();
	RCALL _animate7
; 0000 0162            animate7();
	RCALL _animate7
; 0000 0163         }
; 0000 0164 
; 0000 0165       };
_0x74:
	RJMP _0x65
; 0000 0166 }
_0x75:
	RJMP _0x75

	.ESEG
_mode:
	.DB  0x0
_DelayTime:
	.DB  0xA

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	OUT  0x2D,R30
	OUT  0x2C,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:36 WORDS
SUBOPT_0x1:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x2:
	LD   R30,Y
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:38 WORDS
SUBOPT_0x3:
	LDI  R26,LOW(_mode)
	LDI  R27,HIGH(_mode)
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(5)
	ADD  R5,R30
	LDI  R30,LOW(59)
	CP   R30,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x5:
	LDI  R26,LOW(_DelayTime)
	LDI  R27,HIGH(_DelayTime)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x6:
	RCALL __EEPROMRDB
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	RCALL SUBOPT_0x5
	RCALL __EEPROMWRB
	RCALL SUBOPT_0x5
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 22 TIMES, CODE SIZE REDUCTION:40 WORDS
SUBOPT_0x9:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xA:
	LDI  R30,LOW(1)
	MOV  R7,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:52 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RJMP _SetLed

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xC:
	RCALL SUBOPT_0x5
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	LDI  R26,LOW(7)
	LDI  R27,HIGH(7)
	RCALL __MULW12
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(13)
	CP   R7,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xF:
	ST   -Y,R7
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	RCALL _SetLed
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	RCALL __LSLW2
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x11:
	MOV  R30,R7
	RCALL SUBOPT_0x1
	LDI  R26,LOW(13)
	LDI  R27,HIGH(13)
	SUB  R26,R30
	SBC  R27,R31
	ST   -Y,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 32 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 55 TIMES, CODE SIZE REDUCTION:52 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x14:
	RCALL _SetLed
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(99)
	ST   -Y,R30
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x16:
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	RCALL __MULW12
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x17:
	MOV  R26,R7
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	RCALL _SetLed
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(11)
	MOV  R7,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:75 WORDS
SUBOPT_0x1A:
	RCALL _SetLed
	MOV  R26,R7
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1B:
	ADIW R30,3
	MOVW R26,R30
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RCALL __MODW21
	SUBI R30,-LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1C:
	ADIW R30,7
	MOVW R26,R30
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RCALL __MODW21
	SUBI R30,-LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1D:
	ADIW R30,2
	MOVW R26,R30
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RCALL __MODW21
	SUBI R30,-LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x1E:
	ADIW R30,5
	MOVW R26,R30
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RCALL __MODW21
	SUBI R30,-LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1F:
	ADIW R30,8
	MOVW R26,R30
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RCALL __MODW21
	SUBI R30,-LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x20:
	ST   -Y,R30
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x21:
	RCALL _SetLed
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x22:
	MOV  R26,R3
	LDI  R27,0
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x23:
	RCALL _SetLed
	__DELAY_USW 1200
	RJMP SUBOPT_0x15


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__MULW12U:
	MOV  R0,R26
	MOV  R1,R27
	LDI  R24,17
	CLR  R26
	SUB  R27,R27
	RJMP __MULW12U1
__MULW12U3:
	BRCC __MULW12U2
	ADD  R26,R0
	ADC  R27,R1
__MULW12U2:
	LSR  R27
	ROR  R26
__MULW12U1:
	ROR  R31
	ROR  R30
	DEC  R24
	BRNE __MULW12U3
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
